# AGEVoté v2 Deployment

You will find bellow a quick recap of the architecture and the networking configuration. After that, there are step-by-step deployment instructions.

## Architecture
A global deployment of the AGEVoté v2 e-voting system is comprised of the following :
- 1 **primary deployment** provided by AGEPoly's IT on their infrastructure with a database and a connection to EPFL servers for Tequila.
- (N-1) **secondary deployments** by AGEVoté partners on their own independent IT infrastructure. 
- Gitlab Pages provides the application frontend on https://agepoly.gitlab.io/it/dev/agevote/agevote-frontend/ which is aliased by the main subdomain https://vote.agepoly.ch, the final URL for the users.

*Each* deployment is comprised of
- A [blockchain node](gitlab.com/agepoly/it/dev/agevote/agevote-blockchain), derived from [the template](https://github.com/substrate-developer-hub/substrate-node-template/) provided by [Substrate](https://substrate.io/) (the team behind Polkadot).
- An [application backend](https://gitlab.com/agepoly/it/dev/agevote/agevote-backend) which is either setup as the Primary Backend (AGEPoly) or one of the Secondary Backend (partners).
- A [blockchain sidecar](https://gitlab.com/agepoly/it/dev/agevote/agevote-sidecar) which is a small Node.js application that provides a simple proxy between the application backend and the blockchain node.

## Networking

Component | Internal connectivity | Exposed on the Internet
---|---|---
Application backend | HTTP on port 4000 (also used by sidecar) | HTTPS on any port, routes prefixed by /api
Blockchain node | Web Socket on port 9944 (also used by sidecar) | Web Socket Secure (WSS) on any port (can be merged with backend if filtered on /ws for example)
Blockchain node | TCP 30333 | TCP on any port, no TLS termination required
Sidecar | HTTP on port 9000 (used by backend) | Not exposed

*NB*:
- TLS termination is assured by your infrastructure
- Exposed Web Sockets need to be secured by HTTPS, this is what WSS means
- Internal ports of containers don't interfere with your other deployments so keep the default values. If you really need to, override with environment variables

## Simple deployment based on docker-compose

NB: the current architecture of the AGEVoté blockchain requires a pre-defined set of trusted members. Therefore the deployment needs to be performed in two parts:
- **Part I** : general setup of your environment and automatic key generation
- **Part II** : your node will fetch the latest information about the other chain members and the blockchain will be able to produce finalized blocks (consensus is made)

### **Part I** - Before coordination with primary deployment

1. Use the [docker-compose file](./docker-compose.yml) as a template and edit the relevant parts according to your infrastructure (the volume in particular, the rest should be fine)
2. Both the sidecar and the backend needs environment variables, a [detailed list is available in the common configuration](./configuration/common_configuration.md). You can also copy the example global env file : `cp .env.example .env`
3. Deploy with `docker-compose up -d` or similar according to your infrastructure.
4. Execute the `agevote-setup` command in the blockchain container (named `agevote-blockchain` by default) to generate your keys. (For example with `docker exec -ti agevote-blockchain agevote-setup`)
    Note the resulting
    - **Secret phrase** in the form of a list of words (to be added to the `KEY_PHRASE` env var)
    - **Peer ID** in the form of a Base58-encoded key (to be shared)
    - **Sr25519 public key** in the form of a Base58-encoded key (to be shared)
    - **Ed25519 public key** in the form of a Base58-encoded key (to be shared)
5. A few seconds after the blockchain setup the blockchain node will start. Its log should now display new lines regularly but the current node cannot participate in block finalization yet. You can also restart the sidecar node to use the correct `KEY_PHRASE`, it should not exit anymore.

Share your network peer ID and the 2 public keys generated by the blockchain's setup script. You need to wait until all partners shared their information to the main deployment before proceeding.

**You can find the most up-to-date configuration [here](./configuration/common_configuration.md)**

### **Part II** - After coordination with primary deployment

1. Restart your blockchain node container and check its logs, the count of finalized blocks should now increase (wait ~30s)
2. Check the status of the 3 components, no new errors should be displayed in their logs 

Your deployment is now ready. Some operations still need to be performed before the next voting session. The two most probable are
- an image update of any of the 3 component. Simply change the image tag as specified by AGEPoly.
- a blockchain database reset. More information on [the commands page](./commands.md).